#!/bin/sh
# Exec \
exec tclsh "$0" "$@"

proc timestamp {} {
 return [clock format [clock seconds] -format "\[%Y-%m-%d %H:%M:%S\]" ]
}

cd ~/Napalm
set verbose  0
source "Napalm.conf"
set killings 0
set answer   ""
set from     ""
set to       ""
set subject  ""


set logfile [open "Napalm.log" a]

proc say { what } { 
 global logfile verbose
 puts "$what"
    if { $verbose } { puts $logfile "$what" }
}

proc read_line { } {
 global sock answer logfile
 set answer [gets $sock]
 puts "| Server: \[$answer\]"
 if {[string match "-ERR*" $answer]} { 
  uplevel { 
   say "\\ [timestamp] Napalm leaving operations with $killings confirmed killings due to error \[$answer\]" 
   exit } 
  }
}

proc read_header { } {
 global sock answer from to subject
 set answer ""
 while {1} {
  set line [gets $sock]
  if {[string match "From:*" $line]}    { set from [string range $line 6 end ] }
  if {[string match "To:*" $line]}      { set to   [string range $line 4 end ] }
  if {[string match "Subject:*" $line]} { set subject [string range $line 9 end ] }
  set answer "$answer \n\t$line"
  if {$line=="."} break;
 }
}


proc kill { field pattern } {
 set FIELD   [string toupper $field]
 set PATTERN [string toupper $pattern]
 if {[string match $PATTERN $FIELD]} { 
  uplevel { 
   puts $sock "DELE $i" 
   say "X Napalm killed [format %02i $i]: From: \[$from\] To: \[$to\] Subject: \[$subject\]"
      if {$verbose == 0} {
	  puts $logfile "[timestamp] X From: \[$from\] To: \[$to\] Subject: \[$subject\]" 
      }
   incr killings
  }
 }
}

say "/ [timestamp] Napalm entering war theater, Sir. \[v0.1, www.scarpaz.com\]"
puts "! Connecting to host: $hostname, port: $port"

set sock [socket $hostname $port]
fconfigure $sock -buffering line
read_line
puts $sock "USER $username"; read_line
puts $sock "PASS $password"; read_line
#while {1} {}

scan $answer "+OK %i %i" messages size
set killings 0
for {set i 1} {$i <= $messages } {incr i} {
 puts $sock "TOP $i 1"
 read_header
 puts "| [format %02i $i]: From: \[$from\] To: \[$to\] Subject: \[$subject\]"
 source "Napalm.rules"
}

puts $sock "QUIT"
read_line

say "\\ [timestamp] Napalm completed operations with $killings confirmed killings, Sir."
say " "

close $sock
close $logfile
